<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2006-2009 Franz Holzinger <franz@ttproducts.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Part of the tt_products (Shop System) extension.
 *
 * functions for digital medias view
 *
 * @author  Franz Holzinger <franz@ttproducts.de>
 * @maintainer	Franz Holzinger <franz@ttproducts.de>
 * @package TYPO3
 * @subpackage tt_products
 *
 *
 */


class tx_ttproducts_field_media_view extends tx_ttproducts_field_base_view {


public function getImageCode ($cObj, $imageConf, $theCode) {

        $contentObject = 'IMAGE';
        $imageCode =
            $cObj->getContentObject($contentObject)->render($imageConf);

		if ($theCode == 'EMAIL' && $GLOBALS['TSFE']->absRefPrefix == '') {
			$absRefPrefix = t3lib_div::getIndpEnv('TYPO3_SITE_URL');
			$fixImgCode = str_replace('index.php', $absRefPrefix . 'index.php', $imageCode);
			$fixImgCode = str_replace('src="', 'src="' . $absRefPrefix, $fixImgCode);
			$fixImgCode = str_replace('"uploads/', '"' . $absRefPrefix . 'uploads/', $fixImgCode);
			$imageCode = $fixImgCode;
		}
		return $imageCode;
	}


	/**
	 * replaces a text string with its markers
	 * used for JavaScript functions
	 *
	 * @access private
	 */
	protected function replaceMarkerArray (&$markerArray, &$imageConf, &$row)	{
		if ($imageConf['params'])	{
			$text = $imageConf['params'];
			if (!count($markerArray))	{
				$this->getExtItemMarkerArray($markerArray, $imageConf, $row);
			}
			$text = $this->cObj->substituteMarkerArray($text, $markerArray);
			$imageConf['params'] = $text;
		}
	}

	/**
	 * Template marker substitution
	 * Fills in the markerArray with data for a product
	 *
	 * @return	array		Returns a markerArray ready for substitution with information
	 * 				for the tt_producst record, $row
	 * @access private
	 */
	protected function getExtItemMarkerArray (&$markerArray, $imageConf, &$row)	{
		$markerArray['###IMAGE_FILE###'] = $imageConf['file'];

		foreach ($row as $field => $val)	{
			$key = '###IMAGE_' . strtoupper($field) . '###';
			$markerArray[$key] = $val;
		}
	}

	/* returns the key for the tag array and marker array without leading and ending '###' */
	public function getMarkerkey (&$imageMarkerArray, $markerKey, $imageName, $c = 1, $suffix='')	{
		$keyArray = array();
		$keyArray[] = $markerKey;
		if ($suffix)	{
			$keyArray[] = $suffix;
		}
		if (is_array($imageMarkerArray))	{
			$imageNameArray = t3lib_div::trimExplode('_', $imageName);
			$partsArray = t3lib_div::trimExplode(',', $imageMarkerArray['parts']);
			foreach ($partsArray as $k2 => $part)	{
				$keyArray[] = $imageNameArray[$part-1];
			}
		}
		$tmp = implode('_', $keyArray);
		$tmpArray = t3lib_div::trimExplode('.',$tmp);
		reset($tmpArray);
		$key = current($tmpArray);

		if (!is_array($imageMarkerArray))	{
			$key .= $c;
		}
		return $key;
	}

	public function &getCodeMarkerArray ($functablename, $markerKey, $theCode, &$imageRow, &$imageArray, $dirname, $mediaNum=0, $imageRenderObj, $linkWrap, &$markerArray, &$theImgDAM, &$specialConf)	{

		$imgCodeArray = array();

		$markerArray['###'.$markerKey.'_PATH###'] = $dirname;

		if (count($imageArray))	{
			$cnf = t3lib_div::getUserObj('tx_ttproducts_config');
			$tableConf = $cnf->getTableConf($functablename, $theCode);

			if (is_array($tableConf))	{
				$imageMarkerArray = $tableConf['imageMarker.'];
			}
			$imageConfStart = $this->conf[$imageRenderObj . '.'];
			if ($linkWrap && $imageConfStart['imageLinkWrap'])	{
				$imageConfStart['imageLinkWrap'] = 0;
				unset($imageConfStart['imageLinkWrap.']);
				$imageConfStart['wrap'] = $linkWrap;
			}
			if ($linkWrap === FALSE)	{
				$imageConfStart['imageLinkWrap'] = 0;
			}

			// first loop to get the general markers used also for replacement inside of JavaScript in the setup
			foreach($imageArray as $c => $val)	{
				if ($c == $mediaNum)	{
					break;
				}
				if (!$this->conf['separateImage']) {
					$key = 0;  // show all images together as one image
				} else {
					$key = ($val ? $val : $c);
				}
				$tagkey = '';
				if ($val)	{
					$tagkey = $this->getMarkerkey($imageMarkerArray, $markerKey, $key, $c + 1);
					$filetagkey = $this->getMarkerkey($imageMarkerArray, $markerKey, $key, $c + 1, 'FILE');
					$markerArray['###'.$filetagkey.'###'] = $val;
				}
			}

			foreach($imageArray as $c => $val)	{
//				$confMarkerArray = array();
				$imageConf = $imageConfStart;
				if ($c == $mediaNum)	{
					break;
				}
				$bUseImage = FALSE;
				$meta = FALSE;
				if ($val)	{
					$imageConf['file'] = $dirname.$val;
					$bUseImage = TRUE;
				}
				if (t3lib_extMgm::isLoaded('dam') && $bUseImage && $bImages) {
					$damObj = t3lib_div::getUserObj('tx_dam');
					if(method_exists($damObj,'meta_getDataForFile')) {
						$fieldList = 'uid,pid,tstamp,crdate,active,media_type,title,category,index_type,file_mime_type,file_mime_subtype,
							file_type,file_type_version,file_name,file_path,file_size,file_mtime,file_inode,file_ctime,file_hash,file_status,
							file_orig_location,file_orig_loc_desc,file_creator,file_dl_name,file_usage,meta,ident,creator,
							keywords,description,alt_text,caption,abstract,search_content,language,pages,publisher,copyright,
							instructions,date_cr,date_mod,loc_desc,loc_country,loc_city,hres,vres,hpixels,vpixels,color_space,
							width,height,height_unit';
						$meta = $damObj->meta_getDataForFile($imageConf['file'], $fieldList);
					}
				}

				if (!$this->conf['separateImage']) {
					$key = 0;  // show all images together as one image
				} else {
					$key = ($val ? $val : $c);
				}
				$tagkey = '';
				if ($val)	{
					$tagkey = $this->getMarkerkey($imageMarkerArray, $markerKey, $key, $c + 1);
				}

				$this->cObj->alternativeData = ($meta ? $meta : $imageRow);
				$imageConf['params'] = preg_replace('/\s+/', ' ', $imageConf['params']);
				$this->replaceMarkerArray($markerArray, $imageConf, $this->cObj->alternativeData);

				$tmpImgCode = $this->getImageCode($this->cObj, $imageConf, $theCode);

				if ($tmpImgCode != '')	{
					$imgCodeArray[$key] .= $tmpImgCode;
				}
				if ($meta)	{
					$theImgDAM[$key] = $meta;
				}

				if ($tagkey && is_array($specialConf[$tagkey]))	{
					foreach ($specialConf[$tagkey] as $specialConfType => $specialImageConf)	{
						$theImageConf = array_merge($imageConf, $specialImageConf);
						$this->cObj->alternativeData = ($meta ? $meta : $imageRow); // has to be redone here
						$this->replaceMarkerArray($markerArray, $theImageConf, $this->cObj->alternativeData);
						$tmpImgCode = $this->getImageCode($this->cObj, $theImageConf, $theCode);

						$key1 = $key.':'.$specialConfType;
						$imgCodeArray[$key1] .= $tmpImgCode;
					}
				}
			}	// foreach
		} else if ($this->conf['noImageAvailable'] != '') {	// if (count($imageArray))
			$imageConf = $this->conf[$imageRenderObj . '.'];
			$imageConf['file'] = $this->conf['noImageAvailable'];
			$tmpImgCode = $this->getImageCode($this->cObj, $imageConf, $theCode);
			$imgCodeArray[0] = $tmpImgCode;
		}
		return $imgCodeArray;
	}

	private function getMediaMarkerArray ($functablename, $fieldname, &$row, $mediaNum, $markerKey, &$markerArray, $tagArray, $theCode, $id, &$bSkip, $bHtml = TRUE, $charset = '', $prefix = '', $suffix = '', $imageRenderObj = 'image')	{

		$imageRow = $row;
		$bImages = FALSE;
		$cnf = t3lib_div::getUserObj('tx_ttproducts_config');
		$tableConf = $cnf->getTableConf($functablename, $theCode);
		$tablesObj = t3lib_div::getUserObj('tx_ttproducts_tables');

			// Get image
		$theImgDAM = array();
		$specialImgCode = array();
		if (is_array($tableConf))	{
			$imageMarkerArray = $tableConf['imageMarker.'];
		}
		$imgs = array();
		$imageField = 'image';
		if ($functablename == 'pages')	{
			$imageField = 'media';
		}

		if (is_array($tableConf['fetchImage.']) &&
			$tableConf['fetchImage.']['type'] == 'foreigntable'  &&
			isset($tableConf['fetchImage.']['table'])) {
			$pageContent = $tablesObj->get($tableConf['fetchImage.']['table'])->getFromPid($pid);
			foreach ($pageContent as $pid => $contentRow) {
				if ($contentRow[$imageField]) {
					$imgs[] = $contentRow[$imageField];
				}
			}
			$bImages = TRUE;
		}

		if (!$bImages)	{
			$fieldconfParent = array();
			if (is_array($tableConf))	{
				$tempConf = '';
				if	(
					is_array($tableConf['generateImage.']) &&
					$tableConf['generateImage.']['type'] == 'foreigntable'
				)	{
					$tempConf = &$tableConf['generateImage.'];
				}
				if (is_array($tempConf) && $imageRow)	{
					$conftable = $tempConf['table'];
					$localfield = $tempConf['uid_local'];
					$foreignfield = $tempConf['uid_foreign'];
					$fieldconfParent['generateImage'] = $tempConf['field.'];
					$where_clause = $conftable.'.'.$foreignfield .'='. $imageRow[$localfield];
					$where_clause .= $this->cObj->enableFields($conftable);
					$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', $conftable, $where_clause, '', $foreignfield, 1);
						// only first found row will be used
					$imageRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
				}
			}

			// $confParentTableConf = $this->getTableConf($conftable, $theCode);
			$conftable = ($conftable ? $conftable : $functablename);
			$generateArray = array('generateImage', 'generatePath');
			$nameArray = array();
			$conftableConf = $cnf->getTableConf($conftable, $theCode);

			foreach ($generateArray as $k => $generate)	{
				if (is_array($conftableConf) &&
				 	is_array($conftableConf[$generate.'.'])) {
				 	$genPartArray = $conftableConf[$generate.'.'];
				 	$tableFieldsCode = '';

				 	if ($genPartArray['type'] == 'tablefields')	{
				 		$nameArray[$generate] = '';
				 		$fieldConf = $genPartArray['field.'];

						if (is_array($fieldConf))	{
							if (is_array($fieldconfParent[$generate]))	{
								$fieldConf = array_merge($fieldConf, $fieldconfParent[$generate]);
							}

							foreach ($fieldConf as $field => $count)	{
								if ($imageRow[$field])	{
									$nameArray[$generate] .= substr($imageRow[$field], 0, $count);
									if ($generate == 'generateImage')	{
										$bImages = TRUE;
									}
								}
							}
				 		}
				 	}
				}
			}

			if ($nameArray['generatePath'])	{
				if (is_array($conftableConf['generatePath.']))	{
					$dirname = $conftableConf['generatePath.']['base'].'/'.$nameArray['generatePath'];
				}
				if ($nameArray['generateImage'] && is_dir($dirname))	{
					$directory = dir($dirname);
					while($entry=$directory->read())	{
						if (strstr($entry, $nameArray['generateImage'] . '_') !== FALSE)	{
							$imgs[] = $entry;
						}
					}
					$directory->close();
				}
				if (count($imgs))	{
					$bImages = TRUE;
				}
			}
		}

		if (!$bImages)	{
			$imgs = $this->getModelObj()->getImageArray($imageRow, $imageField);
		}

		$specialConf = array();
		$tempImageConf = '';

		if (is_array($tableConf) &&
			is_array($tableConf['image.']))	{
			$tempImageConf = &$tableConf['image.'];
		}

		if (is_array($tempImageConf))	{
			foreach ($tagArray as $key => $value)	{
				$keyArray = t3lib_div::trimExplode (':', $key);
				$specialConfType = strtolower($keyArray[1]);
				$tagKey = $keyArray[0];
				if ($specialConfType &&
					(!is_array($specialConf[$tagKey]) || !isset($specialConf[$tagKey][$specialConfType]) ) &&
					is_array($tempImageConf[$specialConfType . '.'])
				) {

					// add the special configuration
					if (!is_array($specialConf[$tagKey]))	{
						$specialConf[$tagKey] = array();
					}
					$specialConf[$tagKey][$specialConfType] = &$tempImageConf[$specialConfType.'.'];
				}
			}
		}

		if (isset($dirname))	{
			$dirname .= '/';
		} else {
			$dirname = $this->getModelObj()->getDirname($imageRow);
		}
		$theImgCode = $this->getCodeMarkerArray($functablename, $markerKey, $theCode, $imageRow, $imgs, $dirname, $mediaNum, $imageRenderObj, $linkWrap, $markerArray, $theImgDAM, $specialConf);

		$actImgCode = current($theImgCode);
		$markerArray['###'.$markerKey.'###'] = $actImgCode ? $actImgCode : ''; // for compatibility only

		$c = 1;
		$countArray = array();

		foreach($theImgCode as $k1 => $val) {
			$bIsSpecial = TRUE;
			if (strstr($k1, ':') === FALSE)	{
				$bIsSpecial = FALSE;
			} else {
				$c--; // the former index mus be used again
			}
			$key = $markerKey . intval($c);

 			if ($bIsSpecial)	{
				$keyArray = t3lib_div::trimExplode(':', $k1);
				$count = $countArray[$keyArray[0]];
				$key =  $markerKey . intval($count);

				if (isset($count) && is_array($specialConf[$key]) && isset($specialConf[$key][$keyArray[1]]) && is_array($specialConf[$key][$keyArray[1]]))	{
					$combkey = $key . ':' . strtoupper($keyArray[1]);
					if (isset($tagArray[$combkey]))	{
						$markerArray['###' . $combkey . '###'] = $val;
					}
				}
			} else {
				if (isset($tagArray[$key]))	{
					$markerArray['###'.$key.'###'] = $val;
				}
				$countArray[$k1] = $c;
			}

			if (is_array($theImgDAM[$k1]))	{

				foreach ($theImgDAM[$k1] as $field => $val2)	{
					$key1 = '###' . $key . '_' . strtoupper($field) . '###';
					if (isset($tagArray[$key1]))	{
						$markerArray[$key1] = $val2;
					}
				}
			}
			$c++;
		} // foreach

		$bImageMarker = FALSE;
		if (is_array($tableConf) &&
			is_array($tableConf['imageMarker.']) &&
			$tableConf['imageMarker.']['type'] == 'imagename' )	{
			$bImageMarker = TRUE;
		}

		if ($bImageMarker)	{
			foreach ($theImgCode as $imageName => $imgValue)	{
				$nameArray = t3lib_div::trimExplode(':', $imageName);
				$suffix = ($nameArray[1] ? ':' . $nameArray[1] : '');
				$tagkey = $this->getMarkerkey($imageMarkerArray, $markerKey, $imageName) . strtoupper($suffix);
				if (isset($tagArray[$tagkey]))	{
					$markerArray['###'.$tagkey.'###'] = $imgValue;
				}
				if (is_array($theImgDAM[$imageName]))	{
					foreach ($theImgDAM[$imageName] as $field => $val2)	{
						$key1 = $tagkey . '_' . strtoupper($field);
						if (isset($tagArray[$key1]))	{
							$markerArray['###' . $key1 . '###'] = $val2;
						}
					}
				}
			}
		}
	}


	public function getRowMarkerArray ($functablename, $fieldname, &$row, $markerKey, &$markerArray, $tagArray, $theCode, $id, &$bSkip, $bHtml=TRUE, $charset='', $prefix='', $suffix='', $imageRenderObj='image')	{

		if ($bHtml) {
			$bSkip = TRUE;

			$mediaMarkerKeyArray = array();
			$cnf = t3lib_div::getUserObj('tx_ttproducts_config');
			$tableConf = $cnf->getTableConf($functablename, $theCode);

			foreach ($tagArray as $value => $k1)	{
				if (strpos($value, $markerKey) !== FALSE)	{
					$keyMarker = '###'.$value.'###';
					$foundPos = strpos($value, $markerKey . '_ID');

					if ($foundPos !== FALSE)	{
						$c = substr ($value, strlen($markerKey . '_ID'));
						$markerArray[$keyMarker] = $id . '-' . $c;
					} else {
						$mediaMarkerKeyArray[] = $keyMarker;
					}

					// empty all image fields with no available image
					if (!isset($markerArray[$keyMarker]))	{
						$markerArray[$keyMarker] = '';
					}
				}
			}

			if (count($mediaMarkerKeyArray))	{
				// example: plugin.tt_products.conf.tt_products.ALL.limitImage = 10
				$mediaNum = $tableConf['limitImage'];
				if (!$mediaNum)	{
					$codeTypeArray = array(	// Todo: make this configurable
						'list' => array('real' => array('SEARCH', 'MEMO'), 'part' => array('LIST', 'MENU'), 'num' => $this->conf['limitImage']),
						'basket' => array('real' => array('OVERVIEW', 'BASKET', 'FINALIZE', 'INFO', 'PAYMENT', 'EMAIL'),
							'part' => array() , 'num' => 1),
						'single' => array('real' => array(), 'part' => array('SINGLE'), 'num' => $this->conf['limitImageSingle'])
					);
					foreach ($codeTypeArray as $type => $codeArray)	{
						$realArray = $codeArray['real'];
						if (count ($realArray))	{
							if (in_array($theCode, $realArray))	{
								$mediaNum = $codeArray['num'];
								break;
							}
						}
						$partArray = $codeArray['part'];
						if (count ($partArray))	{
							foreach ($partArray as $k => $part)	{
								if (strpos($theCode, $part) !== FALSE)	{
									$mediaNum = $codeArray['num'];
									break;
								}
							}
						}
					}
				}

				if ($mediaNum)	{

					$this->getMediaMarkerArray(
						$functablename,
						$fieldname,
						$row,
						$mediaNum,
						$markerKey,
						$markerArray,
						$tagArray,
						$theCode,
						$id,
						$bSkip,
						$bHtml,
						$charset,
						$prefix,
						$suffix,
						$imageRenderObj
					);
				}
			}
		}
	}
}


if (defined('TYPO3_MODE') && $GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/tt_products/view/field/class.tx_ttproducts_field_media_view.php']) {
	include_once($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/tt_products/view/field/class.tx_ttproducts_field_media_view.php']);
}


?>